// GESTALT.C : A fuzzy compare.
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "gestalt.h"

int Gestalt::FuzzyCompare(const char *s1,const char *s2)
{

	int l1 = strlen(s1);
	int l2 = strlen(s2);

  if (l1 == 1)
    if (l2 == 1)
      if (*s1 == *s2)
        return(100);

  return(200 * GCsubstr(s1, s1+l1, s2, s2+l2)/ (l1+l2));
}

int Gestalt::GCsubstr(const char *st1,const char *end1,const char *st2,const char *end2)
{
  if (end1 <= st1) return 0;
  if (end2 <= st2) return 0;
  if (end1 == (st1+1) && end2 == (st2+1) ) return 0;

  const char *s1;
  const char *s2;
  int max = 0;
  const char *b1 = end1;
  const char *b2 = end2;

  for (const char *a1 = st1; a1 < b1; a1++)
  {
    for (const char * a2 = st2; a2 < b2; a2++)
    {
      if (*a1 == *a2)
			{

				for (int i=1; a1[i] && (a1[i] == a2[i]); i++);

        if (i > max)
				{
					max = i; s1 = a1; s2 = a2;
					b1 = end1 - max; b2 = end2 - max;
				}

			}
    }
  }

  if (!max) return 0;

  max += GCsubstr(s1+max, end1, s2+max, end2);
  max += GCsubstr(st1, s1, st2, s2);

  return max;
}

